RZDIFF(1)

NAME
RZDIFF - unified binary diffing utility

SYNOPSIS
rz-diff [-AabcCdDhOrspxXvzZ] [-t 0-100] [-g sym] [-S algo] file1 file2

DESCRIPTION
rz-diff implements many binary diffing algorithms for data and code.

-A  Analyze binary after loading it with RzCore (see -C) and use -AA to run aaaa instead of aaa.

-a  Specify architecture (x86, arm, ..)

-b  Select register size bits for given arch

-B  Binary output (GDIFF format)

-c  Count number of differences.

-C  Code diffing using graphdiff algorithm. Output columns are: file-a-address, percentage of most similar function in B file | file-b-address. (Use with -A to analyze the binaries to find more functions)

-d  Use delta diffing (slower).

-D  Show disasm instead of hexpairs (honors -a arch and -b bits)

-e -[k=v]
    Specify eval config vars for all RzCore instances created.

-g sym | off1,off2
    Graph diff output of given symbol, or between two functions, at given offsets: one for each binary.

-G -[cmd]
    Run an rz command on every RzCore instance created

-h  Show usage help message.

-i  Compare the list of imports

-m -[mode]
    Specify the graph output mode

-n  Suppress address names (show only addresses) when code diffing.

-O  Do code diffing with opcode bytes only.

-p  Use physical addressing (io.va=0)

-q  Quiet mode: disable colors and reduce output

-r  Output in rizin commands as a binary patch.

-x  Show two column hexdump diffing.

-X  Show two column hexII diffing.

-s  Calculate text distance from two files.

-ss Same as before but using the Levenstein algorithm (faster but sometimes buggy)

-S [name, namelen, dist, size, ...]
    Specify which column of the code diffing algo use for diffing

-t 0-100
    Choose matching threshold for binary code diffing

-u  Unified diff output

-U  Unified diff output using system's diff program

-v  Show version information.

-V  Be verbose sometimes

-z  Perform diff on extracted strings

-Z  Perform diff using zignatures instead of function list (NEW)

SEE ALSO

rizin(1), rz-find(1), rz-hash(1), rz-bin(1), rz-asm(1), rz-gg(1), rz-run(1), rz-ax(1),

AUTHORS

pancake <pancake@nopcode.org>